## mingw-w64-devil-1.8.0-11.src.tar.zst

=== DevIL/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(ImageLib)

add_subdirectory(src-IL)
add_subdirectory(src-ILU)
add_subdirectory(src-ILUT)
